SystemOrganization addCategory: #'Paradigmas-Quinto'!

BorderedMorph subclass: #Game
	instanceVariableNames: 'cells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Paradigmas-Quinto'!

!Game methodsFor: 'initialization' stamp: 'PEP 8/21/2012 22:48'!
cellsPerSide
	"Devuelve el numero de celdas por lado del juego"
	^ 10! !

!Game methodsFor: 'initialization' stamp: 'PEP 8/21/2012 23:00'!
initialize
	"Inicializar el tablero del game"

	| sampleCell width height n |
	super initialize.
	n := self cellsPerSide.
	sampleCell := Cell new.
	width := sampleCell width.
	height := sampleCell height.
	self bounds: (5@5 extent: ((width*n) @ (height*n)) + (2 * self borderWidth)).
	cells := Matrix new: n tabulate: [:i :j | self newCellAt: i at: j ].! !

!Game methodsFor: 'initialization' stamp: 'PEP 8/21/2012 23:14'!
newCellAt: i at: j 
	"Create a cell for position (i,j) and add it to my on--screen
	representation at the appropriate screen position. Answer the new
	cell "
	| c origin |
	c := Cell new.
	origin := self innerBounds origin.
	self addMorph: c.
	c position: i - 1 * c width @ (j - 1 * c height) + origin.
	c
		mouseAction: [self toggleNeighboursOfCellAt: i at: j].
	^ c! !

!Game methodsFor: 'game logic' stamp: 'PEP 8/21/2012 23:15'!
toggleNeighboursOfCellAt: i at: j 
	i > 1
		ifTrue: [(cells at: i - 1 at: j) toggleState].
	i < self cellsPerSide
		ifTrue: [(cells at: i + 1 at: j) toggleState].
	j > 1
		ifTrue: [(cells at: i at: j - 1) toggleState].
	j < self cellsPerSide
		ifTrue: [(cells at: i at: j + 1) toggleState]! !

SimpleSwitchMorph subclass: #Cell
	instanceVariableNames: 'mouseAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Paradigmas-Quinto'!

!Cell methodsFor: 'initialization' stamp: 'PEP 8/21/2012 11:49'!
initialize
	"initialize game cell"
	super initialize.
	self label: ''.
	self borderWidth: 2.
	bounds := 0@0 corner: 16@16.
	offColor := Color paleYellow.
	onColor := Color paleBlue darker.
	self useSquareCorners.
	self turnOff.
	! !

!Cell methodsFor: 'accessing' stamp: 'PEP 8/21/2012 23:07'!
mouseAction: aBlock
 ^mouseAction := aBlock! !

!Cell methodsFor: 'event handling' stamp: 'PEP 8/21/2012 23:08'!
mouseUp: anEvent 
	mouseAction value! !

Object subclass: #Ejercicio1
	instanceVariableNames: 'expresiones'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Paradigmas-Quinto'!

!Ejercicio1 methodsFor: 'initialize-release' stamp: 'PEP 8/22/2012 15:06'!
initialize
	"inicializar el array que contendra los ejercicios"
	expresiones := {5 + 6. 20 factorial. 'Esto es una prueba' size. #(1 3 5 7 ) at: 2 . 'Paradigmas' isArray . 5 * 7 . 5 // 2 . 4\\3 . 2 / 6 . 15 . Array new . Date today . Time now}! !

!Ejercicio1 methodsFor: 'initialize-release' stamp: 'PEP 8/22/2012 15:10'!
mostrar: aInteger
	| aux |
	"Muestra el resultado de evaluar las expresiones"
	(aInteger isInteger &( aInteger <14) & (aInteger >0)) ifTrue: [aux:=(expresiones at: aInteger)] ifFalse: [aux:= 'Error - Ese Ejercicio no existe!!!!'].
	^ aux.! !
